{SWAG=encrypt.swg,Sune Marcher,fast&good encryption}
unit crypt;
{$g-,o-,n-,e-,x+,t-,v-,q-,r-,s-,a-,f-,i-}

{
  unit:    crypt
  author:  Sune Marcher <suneman@silkeborg.bib.dk>
  date:    8/10/1997
  purpose: to encrypt files fast and unscrambable.
           This uses a "sliding XOR buffer" for it's
           encryption, which is generated from a seed
           value (you can also fill it with your own
           data if you want). This is not a "public-key"
           system, so you still have to find a (secure)
           way to transmit the key. The nice thing about
           this method is that it's VERY fast, and still
           a lot safer than a silly XOR by constant value.
           Also, you can load files into the XOR buffer,
           for instance a couple of pages from the bible
           (or whatever turns you on). It would then be
           next-to-impossible cracking the code if you don't
           have stuff put into the buffer. Effectively, this
           gives you a key longer than 512000 (8*64000) bits...kinda.
}


INTERFACE

function  init_eng(size:word):boolean; { Init the encryption engine. }
procedure reset_eng(size:word);
procedure setslide(slide:word);
procedure maketable(seed:longint);
procedure endecrypt(var buffer;count:word;xorval:longint);

var
  initialized:boolean;            { engine initialized already?        }
  xorbuffer:pointer;              { you might think its bad to have this
				    public, but that way we can load files
				    into the buffer...:-) }

IMPLEMENTATION

var
  oldexit:pointer;
  num_values,mvbl:word;

{$l crypt.obj}
procedure setslide(slide:word); external;
procedure maketable(seed:longint); external;
procedure endecrypt(var buffer;count:word;xorval:longint); external;
{ --- external procedures end --- }

function init_eng(size:word):boolean;
begin
  init_eng:=false;
  if(xorbuffer<>nil)then exit;
  if(size=0)or(maxavail<size)then exit;
  init_eng:=true;
  initialized:=true;
  num_values:=size shr 2;
  mvbl:=size-4;
  getmem(xorbuffer,size);
end;

procedure reset_eng(size:word);
begin
  freemem(xorbuffer,mvbl+4);
  if(size=0)or(maxavail<size)then exit;
  num_values:=size shr 2;
  mvbl:=size-4;
  getmem(xorbuffer,size);
end;

procedure exithandler;far;
begin
  if(mvbl>0)then freemem(xorbuffer,mvbl+4);
  exitproc:=oldexit;
end;

begin
  initialized:=false;
  xorbuffer:=nil;
  oldexit:=exitproc;
  exitproc:=@exithandler;
  num_values:=0;
  mvbl:=0;
end.